/*
 * Program that calculates taylor series for sin(x). For detailed information
 * on taylor series take a look at "Taylor Series Expansion.doc", which is in
 * recitation folder.
 */

#include <iostream>
#include <math.h>
using namespace std;


/*
 * Convert angle from degree to radian
 */
double convert(double angle)
{
	angle = angle * 3.14 / 180;

	return angle;
}

/*
 * Function that calculates factorial of val
 */
double factorial(int val)
{
	int counter = 1;
	double fact = 1;

	while (counter <= val )
	{
		fact = fact * counter;

		counter++;
	}
	
	return fact;
}

/*
 * Function that calculates taylor series for sin(angle) for n=[0,limit]. 
 */
double calSinus(double angle, int limit)
{

	double sinus = 0 ;
	int iter = 0, power = 0;

	angle = convert(angle);

	while ( iter < limit )
	{
		power = 2 * iter + 1;

		double item_num     = pow(angle, power);
		double item_denom   = factorial(power);
		
		sinus = sinus + (item_num / item_denom) * pow(double(-1), double(iter));

		iter++;
	}

	return sinus;
}

int main()
{
	double angle;
	int iter = 0;

	cout << "Enter the angle for sinus function : ";
	cin >> angle;
	cout << endl << "Enter the iteration number for taylor series : ";
	cin >> iter;

	double sinus = calSinus(angle,iter);

	cout << endl << "Function - Sinus("<<angle<<") = " << sinus << endl;

	//to compare result of taylor series calculation with real value of sinus 
	//se sin(x) function of math.h library
	cout << endl << "MATH.H - Sinus("<<angle<<") = " << sin(convert(angle)) << endl << endl;

	return 0;
}
